/*Diana Radeviciute, MIM, 3 pogrupis 
25. Sudaryti dvipusi sarasa. Parasyti paprograme, kuri is saraso pasalina maziausia elementa.*/


#include <stdio.h>
#include <stdlib.h>

struct el {
    int duom;
    struct el *kitas;
    struct el *atgal;
};

//struct el *elem, *elemk;

void Sukurti_sar (struct el **, struct el**);
void Iterpti_elem(struct el **, struct el**, int);
void Spausdinti(struct el* );
void Naikint_min (struct el **, struct el**);
void Naikint_sar (struct el **, struct el**);

int main () {
	struct el *pr = NULL, 
	          *pab, 
			  *elem, 
			  *elemk;
			  
	int reiksme;		  
   
        Sukurti_sar (&pr , &pab);
        Spausdinti (pr);
        Naikint_min (&pr, &pab);
        Spausdinti(pr);
        Naikint_sar (&pr, &pab);
}

void Sukurti_sar(struct el **pr, struct el **pab) {
    int reiksme;   
    printf("Iveskite saraso elementus:\nNoredami baigti, iveskite 0: \n");
    scanf("%d", &reiksme); 
    while(reiksme != 0) {                  
        Iterpti_elem(pr, pab, reiksme);
        scanf("%d", &reiksme);   
    }
    printf("Sarasas sekmingai sukurtas!!!-->");
}

void Iterpti_elem(struct el **pr, struct el **pab, int reiksme) {
    struct el *elem, *tmp;      
    elem = malloc(sizeof(struct el));
    
    if (NULL != elem) {
    	if (*pr==NULL) {   
           elem->duom = reiksme;
           elem->kitas = NULL;
           elem->atgal = NULL;
           *pr = elem;
           *pab = elem;
        }
        else{
            elem->duom = reiksme;
            elem->kitas = NULL;
            elem->atgal = *pab;
            (*pab)->kitas = elem;
            *pab = elem;
        }
    }
    else {
    	printf("Nepavyko isskirti atminties");
    }
}

void Spausdinti(struct el *pr) {
	if (NULL == pr) puts("Tuscias sarasas");
	else {
		printf("%d ", pr->duom);
		if (NULL != pr->kitas) {
			Spausdinti(pr->kitas);
		}
		else {
             printf("\n");
             }
	}
}

void Naikint_min(struct el **pr, struct el **pab) {
	struct el *pradzia = NULL, *pabaiga = NULL, *elem, *elemk;
	
	elem = *pr;
    int min = elem->duom;
	 
    while (elem->kitas != NULL){
        if(min > elem->kitas->duom)
      {
             min = elem->kitas->duom;
      }
      elem = elem->kitas;
    } 
//===========surandam ir trinam min elementa==============================
    printf("Naikiname maziausia elementa:\n");
    elem = *pr;
    while (elem->duom != min) { //ieskom elemento nuo pradzios kuris tures duom = min
        elem = elem->kitas;
    }
    if (elem->atgal == NULL) { // minimumas pradzioije
        elem = *pr;
        *pr = elem->kitas;
        free(elem);
    }
    else if (elem->kitas == NULL) {
        elem = (*pab)->atgal;
        free(*pab);
        *pab = elem;
        (*pab)->kitas = NULL;
    }   
    else { // jei viduryje
       elemk = elem->atgal;                      
       elemk->kitas = elem->kitas;
       elemk->kitas->atgal = elemk;
       free(elem);   
}  
}

void Naikint_sar (struct el **pr, struct el **pab){
   struct el *tmp;
   
    if (NULL != *pr) {
        if (*pr == *pab) {
            free(*pr);
            //*pr = NULL;
            //*pab = NULL;
        }
        else {
            tmp = (*pr)->kitas;
            free(*pr);
            Naikint_sar(&tmp, pab);
            //*pr = NULL;
        }
    }
}
     

